module App

    class AWSProfile

        @@profile     = nil
        @@credentials = nil

        # Reads the config data and attempts to extract the profile.
        # @return void
        def self.init(config_data)

            errors                     = []

            # Get the profile out of the config YML.
            @@profile                  = config_data['AWS']['Profile'] if config_data.has_key?('AWS')

            # If no profile found, return.
            return if @@profile.nil?

            # Check the credentials exist.
            @@credentials, more_errors = Blufin::AWS::get_aws_credentials(@@profile)
            errors.concat(more_errors)

            # If anything is wrong, output error(s).
            Blufin::Config::invalid_configuration(App::GEM_NAME, errors) if errors.any?

        end

        # Get the AWS profile. Returns either the profile (or nil).
        # @return string
        def self.get
            @@profile
        end

        # Convenience method to just get the profile name.
        # @return string
        def self.get_profile_name
            return nil if @@credentials.nil?
            @@profile[PROFILE]
        end

    end

end